/***************************************************************************
 *   Copyright (C) 2004 by Christoph Thielecke                             *
 *   crissi99@gmx.de                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "widgetnotifyhelper.h"
#include <qobjectlist.h>

#include <iostream>


WidgetNotifyHelper::WidgetNotifyHelper(QObject *parent, const char *name)
 : QObject(parent, name)
{
}


WidgetNotifyHelper::~WidgetNotifyHelper()
{
}

void WidgetNotifyHelper::setupChangedAction(QWidget *w)
{
	// connect changed signals to own signal
	QObject *obj;
	QObjectList *list;

	list = w->queryList( "QComboBox" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(textChanged ( const QString & )),w,SIGNAL(changed()));
	}

	list = w->queryList( "KLineEdit" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(textChanged ( const QString & )),w,SIGNAL(changed()));
	}

	list = w->queryList( "QLineEdit" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(textChanged (const QString & )),w,SIGNAL(changed()));
	}

	list = w->queryList( "KUrlRquester" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(textChanged ( const QString & )),w,SIGNAL(changed()));
	}

	list = w->queryList( "QSpinBox" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(valueChanged ( int )),w,SIGNAL(changed()));
	}

	list = w->queryList( "QCheckBox" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(stateChanged ( int )),w,SIGNAL(changed()));
	}

	list = w->queryList( "QRadioButton" );
	for ( obj = list->first(); obj; obj = list->next() )
	{
// 		std::cout << "obj found: " << obj->name() << std::endl;
		connect(obj,SIGNAL(stateChanged ( int )),w,SIGNAL(changed()));
	}

	// connect changed to slot
	connect(w,SIGNAL(changed ()),w,SLOT(dialogChanged()));
}
